# Eclipse iceoryx governance

Eclipse iceoryx is governed democratically by its maintainers under the umbrella of [OpenADx](https://openadx.eclipse.org/).
This document describes the processes additionally to the [Eclipse process](https://www.eclipse.org/projects/handbook/).

## Maintainers

An up to date list of the maintainers can be found at the [Eclipse project page](https://projects.eclipse.org/projects/technology.iceoryx/who).

## Bi-weekly meetup

The developer meetup is held bi-weekly on Thursday from 17:00 - 18:00 CET. Everyone is welcome to join.

You can join by using this Zoom link: https://eclipse.zoom.us/j/95918504483?pwd=RWM5Y1pkeStKVDZsU09EY1hnclREUT09

For a calendar event, you can subscribe to the [ROS calendar](https://calendar.google.com/calendar/u/0/embed?src=agf3kajirket8khktupm9go748@group.calendar.google.com&ctz=America/Los_Angeles).

### Topics

* Propose features
  * E.g. present and discuss design documents
* Discuss pull requests without going into details
  * E.g. a small demo
* Steer direction of Eclipse iceoryx
  * Go over the current release board under Projects
  * E.g. go over the milestone list and move the issues between the three prio's
* Raise and answer questions
* Discuss tooling and infrastructure
* All others topics related to iceoryx one can think of

> Friendly-reminder:
>
> * Discussions about technical issues or in-depth topics should be **avoided**, e.g. "Why is my build broken? I need help"
> * Please stick to the agenda, stay on the topic and move side topics to other meetings

### Meeting minutes

Meeting minutes are stored in the [wiki](https://github.com/eclipse-iceoryx/iceoryx/wiki/Developer-meetup).
An Eclipse maintainer will save the meeting minutes on a new page for every meeting.

If you have points that you want to discuss, please send your points to the [mailing list](mailto:iceoryx-dev@eclipse.org) a couple of days before.

#### Minutes template

```
# Eclipse iceoryx developer meetup

**Date:** 1900/01/01

**Time:** 17:00 CET

**Link:** https://eclipse.zoom.us/j/95918504483?pwd=RWM5Y1pkeStKVDZsU09EY1hnclREUT09

## Attendees

* Max Mustermann, max.mustermann@mustercompany.com
* John Doe, john.doe@doecompany.com

## Agenda

1. General: Introduction of new participators, 42 mins
2. General: Are there other agenda points?, 8 mins
3. Agenda point 1, 4 mins
4. Agenda point 2, 4 mins

## Minutes

### Agenda point 1

* Add discussion here

### Agenda point 2

* Add discussion here

```
